//Pulso de reloj analógico mediante interrupciones internas
/*
 'seta43
'xstaseta@gmail.com
'http: / / seta43.duckdns.org
'http: / / seta43.blogspot.com /
*/
//08/02/2022


#include <avr/io.h>
#include <avr/interrupt.h>

#include <avr/sleep.h>


//#define DEBUG 

#define RTIME 31

byte LedPin=13;
#define PULSADOR 6


#define DS1302_SCLK 15    // A1 Arduino pin for the Serial Clock
#define DS1302_IO   16    // A2 Arduino pin for the Data I/O
#define DS1302_CE   17    // A3 Arduino pin for the Chip Enable


#define DS1302_SECONDS           0x80
#define DS1302_MINUTES           0x82
#define DS1302_HOURS             0x84
#define DS1302_DATE              0x86
#define DS1302_MONTH             0x88
#define DS1302_DAY               0x8A
#define DS1302_YEAR              0x8C
#define DS1302_ENABLE            0x8E
#define DS1302_TRICKLE           0x90
#define DS1302_CLOCK_BURST       0xBE
#define DS1302_CLOCK_BURST_WRITE 0xBE
#define DS1302_CLOCK_BURST_READ  0xBF
#define DS1302_RAMSTART          0xC0
#define DS1302_RAMEND            0xFC
#define DS1302_RAM_BURST         0xFE
#define DS1302_RAM_BURST_WRITE   0xFE
#define DS1302_RAM_BURST_READ    0xFF

#define DS1302_D0 0
#define DS1302_D1 1
#define DS1302_D2 2
#define DS1302_D3 3
#define DS1302_D4 4
#define DS1302_D5 5
#define DS1302_D6 6
#define DS1302_D7 7

#define DS1302_READBIT DS1302_D0 // READBIT=1: read instruction
#define DS1302_RC DS1302_D6
#define DS1302_CH DS1302_D7   // 1 = Clock Halt, 0 = start
#define DS1302_AM_PM DS1302_D5 // 0 = AM, 1 = PM
#define DS1302_12_24 DS1302 D7 // 0 = 24 hour, 1 = 12 hour

#define DS1302_WP DS1302_D7   // 1 = Write Protect, 0 = enabled

#define DS1302_ROUT0 DS1302_D0
#define DS1302_ROUT1 DS1302_D1
#define DS1302_DS0   DS1302_D2
#define DS1302_DS1   DS1302_D2
#define DS1302_TCS0  DS1302_D4
#define DS1302_TCS1  DS1302_D5
#define DS1302_TCS2  DS1302_D6
#define DS1302_TCS3  DS1302_D7


typedef struct ds1302_struct
{
  uint8_t Seconds:4;      // low decimal digit 0-9
  uint8_t Seconds10:3;    // high decimal digit 0-5
  uint8_t CH:1;       // CH = Clock Halt
  
  uint8_t Minutes:4;
  uint8_t Minutes10:3;
  uint8_t reserved1:1;
  
  union
  {
    struct
    {
      uint8_t Hour:4;
      uint8_t Hour10:2;
      uint8_t reserved2:1;
      uint8_t hour_12_24:1; // 0 for 24 hour format
    } h24;
    struct
    {
      uint8_t Hour:4;
      uint8_t Hour10:1;
      uint8_t AM_PM:1;      // 0 for AM, 1 for PM
      uint8_t reserved2:1;
      uint8_t hour_12_24:1; // 1 for 12 hour format
    } h12;
  };
  uint8_t Date:4;
  uint8_t Date10:2;
  uint8_t reserved3:2;
  
  uint8_t Month:4;
  uint8_t Month10:1;
  uint8_t reserved4:3;
  
  uint8_t Day:3;
  uint8_t reserved5:5;
  
  uint8_t Year:4;
  uint8_t Year10:4;
  
  uint8_t reserved6:7;
  uint8_t WP:1;             // WP = Write Protect
};

 ds1302_struct rtc;


byte horas,minutos,segundos,segundos2,segu10,minu10;
byte dia,mes;
int ano;

void printHora();
char buffer[80];     // the code uses 70 characters.


unsigned int time1;
#define TIMER1  200
int repeticion=100;

byte bandera=1;


 void setup()
 {  
  
#ifdef DEBUG  
  Serial.begin(9600);
#endif

  pinMode(LedPin, OUTPUT);
  pinMode(2, OUTPUT); //Segundos
  pinMode(3, OUTPUT);
  pinMode(4, OUTPUT); //Minutos
  pinMode(5, OUTPUT);
  //pinMode(PULSADOR, INPUT);
  //Setup buttons with internal pullup 
  pinMode(PULSADOR,INPUT_PULLUP);
  digitalWrite(PULSADOR,HIGH);
#ifdef DEBUG   
  Serial.println("PULSO RELOJ 31mS");
#endif
  DS1302_write (DS1302_ENABLE, 0);
  DS1302_write (DS1302_TRICKLE, 0x00);
  resetChip();

  watchdogOn(); // Turn on the watch dog timer.
  //ADCSRA = ADCSRA & B01111111;
  //ACSR = B10000000;
}


void loop()
{
  while(1)
  {
    if(repeticion==100)goToSleep();

    if(bandera)
          {
           bandera=0;                                       

           digitalWrite(LedPin, segundos & 1);  
#ifdef DEBUG  
           printHora();
#endif
            increS();
          }

    if(digitalRead(PULSADOR)==0)
      {
        incre10M();
        Serial.println("INC_Minutos");
        delay(repeticion);
        repeticion-=10;
        if(repeticion<10) repeticion=10;
      }

  
  }

}




void increS(void)
{
  repeticion+=20;
  if(repeticion>100) repeticion=100;
  
  segu10++;
  if(segu10>9)
    {
      segu10=0;
      incre10M();
    }
  if(segundos & 1)
    {
      digitalWrite(2, 0);
      digitalWrite(3, 1);
      delay(RTIME);
      digitalWrite(3, 0);
    }
    else
    {
      digitalWrite(3, 0);
      digitalWrite(2, 1);
      delay(RTIME);
      digitalWrite(2, 0);
    }
}


void incre10M(void)
{
  minu10++;
  if(minu10 & 1)
    {
      digitalWrite(4, 0);
      digitalWrite(5, 1);
      delay(RTIME);
      digitalWrite(5, 0);
#ifdef DEBUG       
      Serial.print("x ");
#endif       
    }
    else
    {
      digitalWrite(5, 0);
      digitalWrite(4, 1);
      delay(RTIME);
      digitalWrite(4, 0);
#ifdef DEBUG       
      Serial.print("* ");
#endif       
    }
}





void goToSleep()   
{
set_sleep_mode(SLEEP_MODE_PWR_DOWN); // Set sleep mode.
sleep_enable(); // Enable sleep mode.
sleep_mode(); // Enter sleep mode.
sleep_disable(); // Disable sleep mode after waking.
                     
}



void watchdogOn() 
{
//Fuente http://www.fiz-ix.com/2012/11/low-power-arduino-using-the-watchdog-timer/
// Clear the reset flag, the WDRF bit (bit 3) of MCUSR.
MCUSR = MCUSR & B11110111;
WDTCSR = WDTCSR | B00011000; 
WDTCSR = B00000100; //0.25S
//WDTCSR = B00000101; //0.5S
//WDTCSR = B00000110; //1S
//WDTCSR = B00100001; //8S

// Enable the watchdog timer interupt.
WDTCSR = WDTCSR | B01000000;
MCUSR = MCUSR & B11110111;

}

ISR(WDT_vect)
{
  
  DS1302_clock_burst_read( (uint8_t *) &rtc);
  
  segundos2=(rtc.Seconds10 * 10) + rtc.Seconds;
  if(segundos!=segundos2)
    {
     bandera=1;

     segundos=segundos2;
     minutos=(rtc.Minutes10 * 10) + rtc.Minutes;
     horas=(rtc.h24.Hour10 * 10) + rtc.h24.Hour;
     dia=(rtc.Date10 * 10) + rtc.Date;
     mes=(rtc.Month10 * 10) + rtc.Month;
     ano=2000+(rtc.Year10 * 10) + rtc.Year;
   
    }
    
}




//------------------------------------------
void resetChip()
{
  memset ((char *) &rtc, 0, sizeof(rtc));
  rtc.Seconds = 0;
  rtc.Seconds10 = 0;
  rtc.CH = 0;        // 1 for Clock Halt, 0 to run;
  rtc.Minutes = 0;
  rtc.Minutes10 = 0;
  rtc.h24.Hour = 0;
  rtc.h24.Hour10 = 0;
  rtc.h24.hour_12_24 = 0; // 0 for 24 hour format
  rtc.Date = 1;
  rtc.Date10 = 0;
  rtc.Month = 1;
  rtc.Month10 = 0;
  rtc.Day = 1;
  rtc.Year = 1;
  rtc.Year10 = 1;
  rtc.WP = 0;  
  DS1302_clock_burst_write( (uint8_t *) &rtc);
}


void printHora()
{
#ifdef DEBUG  
     sprintf(buffer,"%02d:%02d:%02d",horas,minutos,segundos); 
     Serial.println(buffer);
#endif     


}




void DS1302_clock_burst_read( uint8_t *p)
{
  int i;

  _DS1302_start();
  _DS1302_togglewrite( DS1302_CLOCK_BURST_READ, true);  
  for (i=0; i<8; i++)    *p++ = _DS1302_toggleread();  
  _DS1302_stop();
}


void DS1302_clock_burst_write( uint8_t *p)
{
  int i;

  _DS1302_start();
  _DS1302_togglewrite( DS1302_CLOCK_BURST_WRITE, false);  
  for (i=0; i<8; i++)    _DS1302_togglewrite( *p++, false);  
  _DS1302_stop();
}

uint8_t DS1302_read(int address)
{
  uint8_t data;

  bitSet (address, DS1302_READBIT);  
  _DS1302_start();
  _DS1302_togglewrite (address, true);  
  data = _DS1302_toggleread ();
  _DS1302_stop();

  return (data);
}

void DS1302_write(int address, uint8_t data)
{
  bitClear (address, DS1302_READBIT);  

  _DS1302_start();
  _DS1302_togglewrite (address, false);
  _DS1302_togglewrite (data, false);
  _DS1302_stop();  
}

void _DS1302_start(void)
{
  digitalWrite (DS1302_CE, LOW); // default, not enabled
  pinMode (DS1302_CE, OUTPUT);  
  digitalWrite (DS1302_SCLK, LOW); // default, clock low
  pinMode (DS1302_SCLK, OUTPUT);
  pinMode (DS1302_IO, OUTPUT);
  digitalWrite (DS1302_CE, HIGH); // start the session
  delayMicroseconds(4);           // tCC = 4us
}

void _DS1302_stop(void)
{
  digitalWrite (DS1302_CE, LOW);
  delayMicroseconds(4);           // tCWH = 4us
}


uint8_t _DS1302_toggleread(void)
{
  uint8_t i, data;

  data = 0;
  for (i = 0; i <= 7; i++)
  {
    digitalWrite (DS1302_SCLK, HIGH);
    delayMicroseconds(1);
    digitalWrite (DS1302_SCLK, LOW);
    delayMicroseconds(1);        // tCL=1000ns, tCDD=800ns
    bitWrite (data, i, digitalRead(DS1302_IO));
  }
  return (data);
}


void _DS1302_togglewrite(uint8_t data, uint8_t release)
{
  int i;

  for (i = 0; i <= 7; i++)
  {
    digitalWrite (DS1302_IO, bitRead(data, i));  
    delayMicroseconds(1);     // tDC = 200ns
    digitalWrite (DS1302_SCLK, HIGH);    
    delayMicroseconds(1);     // tCH = 1000ns, tCDH = 800ns
    if (release && i == 7)
    {
      pinMode (DS1302_IO, INPUT);
      digitalWrite (DS1302_IO, LOW); // remove any pull-up  
    }
    else
    {
      digitalWrite (DS1302_SCLK, LOW);
      delayMicroseconds(1);       // tCL=1000ns, tCDD=800ns
    }
  }
}


//___________________________________________
